#include <stdio.h>
#include <Xm/Xm.h>
#include <Xm/Label.h>
#include <linux/sched.h>

static int msec;

struct es_param eso;
int i, j, rtrn;
int qid[ES_MAX_RQ];
char buf[80];
char lines[2048];
char ver[10]={"1.3"};
char program[10]={"xesep-es"};
char date[30]={"December 28, 1997"};

static XtAppContext app;
Arg args[10];
XmString xms;

int get_status()
{
  if((rtrn=syscall(SYS_ES_NICE, ES_GET_STATUS, &eso))!=ES_TRUE) 
    return ES_FAULT;

  for (i=0; i< eso.process_no; i++)
  {
    qid[eso.rq_queue_id[i]]=1;
  }
  return ES_TRUE;
}

int draw_pr_info(Widget w)
{
  sprintf(lines, "%s", "");
  sprintf(lines, "%sPCY CTX\n", lines);
  sprintf(lines, "%s %s%4d\n",
    lines,
    "PR",
    eso.context_switch);

  sprintf(lines, "%s\n", lines); 
  sprintf(lines, "%s PID RUN CNT PRI RTP  CMD\n", lines);

  for (i=0; i< eso.process_no; i++)
  {
    eso.comm[i][8]='\0';
    sprintf(lines, "%s%4d %3d  %2d  %2d  %2d  %s\n", 
      lines,
      eso.pid[i], 
      eso.rq_process_run[i], 
      eso.counter[i], 
      eso.priority[i],
      eso.rt_priority[i],
      eso.comm[i]);
  }

  xms = XmStringLtoRCreate(lines, XmSTRING_DEFAULT_CHARSET);
  XtSetArg(args[0], XmNlabelString, xms);
  XtSetArg(args[1], XmNwidth, 250); 
  XtSetArg(args[2], XmNheight, 140); 
  XtSetArg(args[3], XmNresizePolicy, XmRESIZE_ANY);  
  XtSetArg(args[4], XmNalignment, XmALIGNMENT_BEGINNING);  
  XtSetValues(w, args, 5);  
  XmStringFree(xms);

  return(ES_TRUE);
}

int draw_es_info(Widget w)
{
  sprintf(lines, "%s", "");
  sprintf(lines, "%sPCY QID CTX  POF             QOF             SYS\n", lines);
  sprintf(lines, "%s %s  %1d %4d %3d%3d%3d%3d%3d %3d%3d%3d%3d%3d  %d %d %d %d %d\n",
    lines, 
    "ES",
    eso.default_queue_id,
    eso.context_switch,
    eso.default_process_objective_function[0],
    eso.default_process_objective_function[1],
    eso.default_process_objective_function[2],
    eso.default_process_objective_function[3],
    eso.default_process_objective_function[4],
    eso.default_queue_objective_function[0],
    eso.default_queue_objective_function[1],
    eso.default_queue_objective_function[2],
    eso.default_queue_objective_function[3],
    eso.default_queue_objective_function[4],
    eso.base_free,
    eso.system_free,
    eso.cpu_free,
    eso.mem_free,
    eso.disk_free);

  sprintf(lines, "%s\n", lines);
  sprintf(lines, "%s QID RUN GUA   FIT   QOF\n", lines);

  for (i=1; i< ES_MAX_RQ; i++)
  {
    if(qid[i]==ES_TRUE)
    {
      sprintf(lines, "%s  %1d  %3d %1d/%1d %3d/%d %3d%3d%3d%3d%3d\n", 
        lines,
        i,
        eso.queue_run[i], 
        eso.queue_guarantee_value[i],
        eso.queue_guarantee_value_last[i],
        eso.queue_fitness_value[i],
        eso.queue_fitness_value_last[i],
        eso.queue_objective_function[i][0],
        eso.queue_objective_function[i][1],
        eso.queue_objective_function[i][2],
        eso.queue_objective_function[i][3],
        eso.queue_objective_function[i][4]);
    }
  }

  sprintf(lines, "%s\n", lines);
  sprintf(lines, "%s PID QID RUN CNT PRI RTP GUA   FIT    POF             QOF             CMD\n", lines);

  for (i=0; i< eso.process_no; i++)
  {
    eso.comm[i][8]='\0';
    sprintf(lines, "%s%4d  %1d  %3d  %2d  %2d  %2d %1d/%d %3d/%d %3d%3d%3d%3d%3d %3d%3d%3d%3d%3d  %s\n", 
      lines,
      eso.pid[i], 
      eso.rq_queue_id[i], 
      eso.rq_process_run[i], 
      eso.counter[i], 
      eso.priority[i], 
      eso.rt_priority[i], 
      eso.rq_process_guarantee_value[i],
      eso.rq_process_guarantee_value_last[i],
      eso.rq_process_fitness_value[i],
      eso.rq_process_fitness_value_last[i],
      eso.rq_process_objective_function[i][0],
      eso.rq_process_objective_function[i][1],
      eso.rq_process_objective_function[i][2],
      eso.rq_process_objective_function[i][3],
      eso.rq_process_objective_function[i][4],
      eso.rq_queue_objective_function[i][0],
      eso.rq_queue_objective_function[i][1],
      eso.rq_queue_objective_function[i][2],
      eso.rq_queue_objective_function[i][3],
      eso.rq_queue_objective_function[i][4],
      eso.comm[i]);
  }

  xms = XmStringLtoRCreate(lines, XmSTRING_DEFAULT_CHARSET);
  XtSetArg(args[0], XmNlabelString, xms);
  XtSetArg(args[1], XmNwidth, 560); 
  XtSetArg(args[2], XmNheight, 200); 
  XtSetArg(args[3], XmNresizePolicy, XmRESIZE_ANY);  
  XtSetArg(args[4], XmNalignment, XmALIGNMENT_BEGINNING);  
  XtSetValues(w, args, 5);  
  XmStringFree(xms);

  return(ES_TRUE);
}

void draw(Widget w)
{
  get_status();

  if(eso.default_policy==ES_SCHED_ES)
  {
    rtrn=draw_es_info(w);
  }
  else
  {
    rtrn=draw_pr_info(w);
  }

  XtAppAddTimeOut(app, msec, (XtTimerCallbackProc) draw, w);
}

void main(int argc, char **argv)
{
  Widget top_level, label_esep;

  msec=1000;
  if(argc==2)
  {
    msec=atoi(argv[1]);
    if((msec>20000)||(msec<1)) msec=1000;
  }

  top_level = XtAppInitialize(&app, "xesep-es", NULL, 0,
                                &argc, argv, NULL, NULL, 0);

  label_esep=XmCreateLabel(top_level, "xesep-es", NULL, 0);

  XtManageChild(label_esep);
  draw(label_esep);

  XtRealizeWidget(top_level);

  XtAppMainLoop(app);
}
