#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <Xm/Xm.h>
#include <Xm/MainW.h>
#include <Xm/DrawingA.h>
#include <linux/sched.h>

struct es_param eso;
int i, j, rtrn;
int qid[ES_MAX_RQ];
char buf[80];
char ver[10]={"1.3"};
char date[30]={"December 28, 1997"};
char program[10]={"xesep-qs"};
char project[80]={"Evolution Scheduling and Evolving Processes"};
static int msec;

GC theGC;
XTextItem items;
Arg args[20];
XtAppContext app;

int get_status()
{
  if((rtrn=syscall(SYS_ES_NICE, ES_GET_STATUS, &eso))!=ES_TRUE) 
    return ES_FAULT;

  for (i=0; i< eso.process_no; i++)
  {
    qid[eso.rq_queue_id[i]]=1;
  }
  return ES_TRUE;
}

int draw(Widget w)
{
  get_status();

  if(eso.default_policy==ES_SCHED_ES)
  {
    XClearArea(XtDisplay(w), XtWindow(w), 0, 0, 0, 0, True);
    draw_text(XtDisplay(w), XtWindow(w), theGC);
    draw_bar(XtDisplay(w), XtWindow(w), theGC);
    XtAppAddTimeOut(app, msec, (XtTimerCallbackProc)draw, w);
  }
  else
  {
    sprintf(buf, "%s %s %s", program, ver, date);
    items.chars=buf;
    items.nchars=strlen(buf);
    items.delta=10;
    items.font=None;
    XDrawText(XtDisplay(w), XtWindow(w), theGC, 10, 50, &items, 1);
  }
}

int main(int argc, char **argv)
{
  Widget top_level, main_window, drawing_area; 
  Cardinal argcount;
  XGCValues xgcv;

  msec=1000;
  if(argc==2)
  {
    msec=atoi(argv[1]);
    if((msec>20000)||(msec<1)) msec=1000;
  }

  top_level = XtAppInitialize(&app, "xesep-qs", NULL, 0,
                                  &argc, argv, NULL, NULL, 0);

  main_window = XmCreateMainWindow(top_level, "xesep-qs", 
    args, 0);
  XtManageChild(main_window);

  argcount = 0;
  XtSetArg(args[argcount], XmNresizePolicy, XmRESIZE_ANY);  argcount++;
  XtSetArg(args[argcount], XmNwidth, 250);   argcount++;
  XtSetArg(args[argcount], XmNheight, 110); argcount++;
  drawing_area = XmCreateDrawingArea(main_window, 
    "drawing_area", args, argcount);

  XtManageChild(drawing_area);

  XmMainWindowSetAreas(main_window, NULL, NULL, NULL, 
    NULL, drawing_area);

  theGC = XtGetGC(drawing_area, GCForeground | GCBackground, 
    &xgcv);

  XtRealizeWidget(top_level);

  XtAppAddTimeOut(app, 100, (XtTimerCallbackProc)draw, drawing_area);
  XtAppMainLoop(app);
}

int draw_bar(Display *d, Window w, GC gc)
{
  int i, j;

  j=0;
  for (i=1; i< ES_MAX_RQ; i++)
  {
    if(qid[i]==ES_TRUE)
    {
      XDrawRectangle(d, w, gc, 78, j*20+20, 103, 10);
      XFillRectangle(d, w, gc, 80, j*20+22, 
        100*eso.queue_fitness_value[i]/255, 7);
      j++;
    }
  }
}

int draw_text(Display *d, Window w, GC gc)
{ 
  int i, j;
  j=0;
  for (i=1; i< ES_MAX_RQ; i++)
  {
    if(qid[i]==ES_TRUE)
    {
      sprintf(buf, "queue %02d                     %d  ",
        i, eso.queue_fitness_value[i]); 
      items.chars=buf;
      items.nchars=strlen(buf);
      items.delta=10;
      items.font=None;
      XDrawText(d, w, gc, 10, j*20+30, &items, 1);
      j++;
    }
  }
}


