#include <stdio.h>
#include <varargs.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Intrinsic.h>
#include <Xm/Xm.h>
#include <Xm/RowColumn.h>
#include <Xm/MainW.h>
#include <Xm/PushB.h>
#include <Xm/CascadeB.h>
#include <Xm/Text.h>
#include <Xm/Label.h>
#include <Xm/Form.h>

typedef void (*P_FUNC)();
typedef char *P_CHAR;

XtAppContext app;

static int opt[10]={0,1,2,3,4,5,6,7,8,9};
static char buf[256];
int ms, help, ss, ps, qs, es, i, argc;
char **argv;

static msec=1000;

GC theGC;
XmString xms;
Arg args[20];
Cardinal argcount;

char ver[10]={"1.3"};
char program[10]={"xesep"};
char date[30]={"December 28, 1997"};
char project[50]={"Evolution Scheduling and Evolving Processes"};

void files();
void options();

static void callback_status_arm();
static void callback_status_disarm();
static void callback_clear();
static void callback_exec();
static void callback_help();

Widget top_level, main_window, menu_bar, form_esep, 
  new_menu, button_exec, button_clear, button_status, button_help,
  label_esep, label_cp, label_cq, 
  label_cpo, label_cqo, label_mp, label_mq, 
  label_q, label_po, label_qo, label_bg, 
  text_esep, text_cp, text_cq,
  text_cpo, text_cqo, text_mp, text_mq,
  text_q, text_po, text_qo, text_bg;

Widget MakeMenuPane();
void AttachToCascade();

int print_help()
{
  printf("\n");
  printf("usage: Evolution Scheduling and Evolving Processes   Ver:%s  Date:%s\n", ver, date);
  printf("\n");
  printf("    %s [-options...]\n", argv[0]);
  printf("\n");
  printf("  where options include:\n");
  printf("\n");
  printf("    -help|-h   print out this message\n");
  printf("\n");
  printf("    -ss        display system status on Xwindow\n");
  printf("\n");
  printf("    -ps        display evolving process status on Xwindow\n");
  printf("\n");
  printf("    -qs        display queue status on Xwindow\n");
  printf("\n");
  printf("    -es        display evolution scheduling status on Xwindow\n");
  printf("\n");
  printf("    -ms        specify the refresh rate in mini-(milli-)seconds.\n");
  printf("\n");
  printf("  examples: see man %s(1x)\n", argv[0]);
  printf("\n");
  printf("    you many simply start the program by \"%s\"\n", argv[0]);
  printf("\n");
  printf("\n");
  return(1);
}

int check_ms()
{
  ms=0;
  for(i=1; i<argc; i++)
  {
    if(strcmp(argv[i], "-ms")==0)
    {
      ms=atoi(argv[i+1]);
      if(ms<1) ms=0;
      if(ms>20000) ms=0;
      i=argc;
    }
  }
  return(1);
}

int check_help()
{
  help=0;
  for(i=1; i<argc; i++)
  {
    if((strcmp(argv[i], "-help")==0)||(strcmp(argv[i], "-h")==0))
    {
      help=1;
      i=argc;
    }
  }
  return(1);
}

int check_ss()
{
  ss=0;
  for(i=1; i<argc; i++)
  {
    if(strcmp(argv[i], "-ss")==0)
    {
      ss=1;
      i=argc;
    }
  }
  return(1);
}

int check_ps()
{
  ps=0;
  for(i=1; i<argc; i++)
  {
    if(strcmp(argv[i], "-ps")==0)
    {
      ps=1;
      i=argc;
    }
  }
  return(1);
}

int check_qs()
{
  qs=0;
  for(i=1; i<argc; i++)
  {
    if(strcmp(argv[i], "-qs")==0)
    {
      qs=1;
      i=argc;
    }
  }
  return(1);
}

int check_es()
{
  es=0;
  for(i=1; i<argc; i++)
  {
    if(strcmp(argv[i], "-es")==0)
    {
      es=1;
      i=argc;
    }
  }
  return(1);
}

void print_status(char *str) 
{
  xms = XmStringLtoRCreate(str, XmSTRING_DEFAULT_CHARSET);
  XtSetArg(args[0], XmNlabelString, xms);
  XtSetArg(args[1], XmNalignment, XmALIGNMENT_CENTER); 
  XtSetValues(button_status, args, 2);  
  XmStringFree(xms);
}

void callback_clear(Widget w, XtPointer client_data, 
  XmAnyCallbackStruct *call_data)
{
  XmTextSetString(text_esep, ""); 
  XmTextSetString(text_cp, ""); 
  XmTextSetString(text_cq, ""); 
  XmTextSetString(text_cpo, ""); 
  XmTextSetString(text_cqo, ""); 
  XmTextSetString(text_mp, ""); 
  XmTextSetString(text_mq, ""); 
  XmTextSetString(text_q, ""); 
  XmTextSetString(text_po, ""); 
  XmTextSetString(text_qo, ""); 
  print_status("clear all the text fields");
}

void callback_exec(Widget w, XtPointer client_data, 
  XmAnyCallbackStruct *call_data)
{
  int sel;
  char esep[80], cp[80], cq[80], cpo[80], cqo[80], mp[80], mq[80],
    q[80], po[80], qo[80];

  sprintf(esep, "%s", XmTextGetString(text_esep));
  sprintf(cp, "%s", XmTextGetString(text_cp));
  sprintf(cq, "%s", XmTextGetString(text_cq));
  sprintf(cpo, "%s", XmTextGetString(text_cpo));
  sprintf(cqo, "%s", XmTextGetString(text_cqo));
  sprintf(mp, "%s", XmTextGetString(text_mp));
  sprintf(mq, "%s", XmTextGetString(text_mq));
  sprintf(q, "%s", XmTextGetString(text_q));
  sprintf(po, "%s", XmTextGetString(text_po));
  sprintf(qo, "%s", XmTextGetString(text_qo));

  sprintf(buf, "%s", "esep");
  if(strlen(esep)>0) sprintf(buf, "%s \"%s\"", buf, esep);
  if(strlen(cp)>0) sprintf(buf, "%s -cp %s", buf, cp);
  if(strlen(cq)>0) sprintf(buf, "%s -cq %s", buf, cq);
  if(strlen(cpo)>0) sprintf(buf, "%s -cpo %s", buf, cpo);
  if(strlen(cqo)>0) sprintf(buf, "%s -cqo %s", buf, cqo);
  if(strlen(mp)>0) sprintf(buf, "%s -mp %s", buf, mp);
  if(strlen(mq)>0) sprintf(buf, "%s -mq %s", buf, mq);
  if(strlen(q)>0) sprintf(buf, "%s -q %s", buf, q);
  if(strlen(po)>0) sprintf(buf, "%s -po %s", buf, po);
  if(strlen(qo)>0) sprintf(buf, "%s -qo %s", buf, qo);

  sprintf(buf, "%s &", buf);
  system(buf);
  print_status(buf);
}

void callback_help(Widget w, XtPointer client_data, 
  XmAnyCallbackStruct *call_data)
{
  sprintf(buf, "%s", "xterm -font 7x14 -e man xesep &");
  system(buf);
  print_status(buf);
}

void callback_status_arm(Widget w, XtPointer client_data, 
  XmAnyCallbackStruct *call_data)
{
  sprintf(buf, "%s %s %s", program, ver, date);
  print_status(buf);
}

void callback_status_disarm(Widget w, XtPointer client_data, 
  XmAnyCallbackStruct *call_data)
{
  print_status(project);
}

void main(int margc, char **margv)
{
  int i;

  argc=margc;
  argv=margv;
  check_ms();
  check_ss();
  check_ps();
  check_qs();
  check_es();
  check_help();

  if(ms>0) msec=ms;

  if(help>0)
  {
    print_help();
    exit(1);
  }
  if(ss>0)
  { 
    sprintf(buf, "%s %d &", "xesep-ss", msec);
    system(buf);
    exit(0);
  }
  if(ps>0)
  { 
    sprintf(buf, "%s %d &", "xesep-ps", msec);
    system(buf);
    exit(0);
  }
  if(qs>0)
  { 
    sprintf(buf, "%s %d &", "xesep-qs", msec);
    system(buf);
    exit(0);
  }
  if(es>0)
  { 
    sprintf(buf, "%s %d &", "xesep-es", msec);
    system(buf);
    exit(0);
  }

  top_level = XtAppInitialize(&app, "xesep", NULL, 0,
    &argc, argv, NULL, NULL, 0);

  main_window = XmCreateMainWindow(top_level, "main", 
    args, 0);
  XtManageChild(main_window);

  menu_bar = XmCreateMenuBar(main_window, "menubar", NULL, 0);
  XtManageChild(menu_bar);

  XtSetArg(args[0], XmNwidth, 580);
  XtSetArg(args[1], XmNheight, 100);
  form_esep=XmCreateForm(main_window, "form", args, 2);

  XtManageChild(form_esep);

  XmMainWindowSetAreas(main_window, menu_bar, NULL, NULL, 
    NULL, form_esep);

  new_menu = MakeMenuPane("File", menu_bar, 
    "system status (xesep-ss)", files, (XtPointer)&opt[0],
    "process status (xesep-ps)", files, (XtPointer)&opt[1],
    "queue status (xesep-qs)", files, (XtPointer)&opt[2],
    "esep status (xesep-es)", files, (XtPointer)&opt[3],
    "exit", files, (XtPointer)&opt[4],
    NULL);
  AttachToCascade(menu_bar, "File ", new_menu);

  new_menu = MakeMenuPane("Options", menu_bar, 
    "1 msec", options, (XtPointer)&opt[0],
    "10 msecs", options, (XtPointer)&opt[1],
    "100 msecs", options, (XtPointer)&opt[2],
    "one second", options, (XtPointer)&opt[3],
    "two seconds", options, (XtPointer)&opt[4],
    "three seconds", options, (XtPointer)&opt[5],
    "ten seconds", options, (XtPointer)&opt[6],
    "twenty seconds", options, (XtPointer)&opt[7],
    NULL);
  AttachToCascade(menu_bar, "Options ", new_menu);

  XtSetArg(args[0], XmNrecomputeSize, False);
  button_status=XmCreatePushButton(menu_bar, project, args, 1);
  XtManageChild(button_status);
  XtAddCallback(button_status, XmNarmCallback, 
    (XtCallbackProc) callback_status_arm, NULL);
  XtAddCallback(button_status, XmNdisarmCallback, 
    (XtCallbackProc) callback_status_disarm, NULL);

  XtSetArg(args[0], XmNrecomputeSize, False);
  button_clear=XmCreatePushButton(menu_bar, "clear", args, 1);
  XtManageChild(button_clear);
  XtAddCallback(button_clear, XmNarmCallback, 
    (XtCallbackProc) callback_clear, NULL);

  XtSetArg(args[0], XmNrecomputeSize, False);
  button_exec=XmCreatePushButton(menu_bar, " exec ", args, 1);
  XtManageChild(button_exec);
  XtAddCallback(button_exec, XmNarmCallback, 
    (XtCallbackProc) callback_exec, NULL);

  XtSetArg(args[0], XmNrecomputeSize, False);
  button_help=XmCreatePushButton(menu_bar, " Help ", args, 1);
  XtManageChild(button_help);
  XtAddCallback(button_help, XmNarmCallback, 
    (XtCallbackProc) callback_help, NULL);

  xms = XmStringLtoRCreate("esep", XmSTRING_DEFAULT_CHARSET);
  XtSetArg(args[0], XmNlabelString, xms);
  XtSetArg(args[1], XmNx, 10);
  XtSetArg(args[2], XmNy, 20);
  label_esep=XmCreateLabel(form_esep, "label_esep", args, 3);
  XtManageChild(label_esep);
  XmStringFree(xms);

  XtSetArg(args[0], XmNeditable, True);
  XtSetArg(args[1], XmNcolumns, 12);
  XtSetArg(args[2], XmNx, 45);
  XtSetArg(args[3], XmNy, 15);
  text_esep=XmCreateText(form_esep, "text_esep", args, 4);
  XtManageChild(text_esep);

  xms = XmStringLtoRCreate("-cp", XmSTRING_DEFAULT_CHARSET);
  XtSetArg(args[0], XmNlabelString, xms);
  XtSetArg(args[1], XmNx, 145);
  XtSetArg(args[2], XmNy, 20);
  label_cp=XmCreateLabel(form_esep, "label_cp", args, 3);
  XtManageChild(label_cp);
  XmStringFree(xms);

  XtSetArg(args[0], XmNeditable, True);
  XtSetArg(args[1], XmNcolumns, 2);
  XtSetArg(args[2], XmNx, 170);
  XtSetArg(args[3], XmNy, 15);
  text_cp=XmCreateText(form_esep, "text_cp", args, 4);
  XtManageChild(text_cp);

  xms = XmStringLtoRCreate("-cq", XmSTRING_DEFAULT_CHARSET);
  XtSetArg(args[0], XmNlabelString, xms);
  XtSetArg(args[1], XmNx, 200);
  XtSetArg(args[2], XmNy, 20);
  label_cq=XmCreateLabel(form_esep, "label_cq", args, 3);
  XtManageChild(label_cq);
  XmStringFree(xms);

  XtSetArg(args[0], XmNeditable, True);
  XtSetArg(args[1], XmNcolumns, 2);
  XtSetArg(args[2], XmNx, 225);
  XtSetArg(args[3], XmNy, 15);
  text_cq=XmCreateText(form_esep, "text_cq", args, 4);
  XtManageChild(text_cq);

  xms = XmStringLtoRCreate("-cpo", XmSTRING_DEFAULT_CHARSET);
  XtSetArg(args[0], XmNlabelString, xms);
  XtSetArg(args[1], XmNx, 255);
  XtSetArg(args[2], XmNy, 20);
  label_cpo=XmCreateLabel(form_esep, "label_cqo", args, 3);
  XtManageChild(label_cpo);
  XmStringFree(xms);

  XtSetArg(args[0], XmNeditable, True);
  XtSetArg(args[1], XmNcolumns, 15);
  XtSetArg(args[2], XmNx, 285);
  XtSetArg(args[3], XmNy, 15);
  text_cpo=XmCreateText(form_esep, "text_cpo", args, 4);
  XtManageChild(text_cpo);

  xms = XmStringLtoRCreate("-cqo", XmSTRING_DEFAULT_CHARSET);
  XtSetArg(args[0], XmNlabelString, xms);
  XtSetArg(args[1], XmNx, 405);
  XtSetArg(args[2], XmNy, 20);
  label_cqo=XmCreateLabel(form_esep, "label_cqo", args, 3);
  XtManageChild(label_cqo);
  XmStringFree(xms);

  XtSetArg(args[0], XmNeditable, True);
  XtSetArg(args[1], XmNcolumns, 15);
  XtSetArg(args[2], XmNx, 435);
  XtSetArg(args[3], XmNy, 15);
  text_cqo=XmCreateText(form_esep, "text_cqo", args, 4);
  XtManageChild(text_cqo);

  xms = XmStringLtoRCreate("-mp", XmSTRING_DEFAULT_CHARSET);
  XtSetArg(args[0], XmNlabelString, xms);
  XtSetArg(args[1], XmNx, 65);
  XtSetArg(args[2], XmNy, 55);
  label_mp=XmCreateLabel(form_esep, "label_mp", args, 3);
  XtManageChild(label_mp);
  XmStringFree(xms);

  XtSetArg(args[0], XmNeditable, True);
  XtSetArg(args[1], XmNcolumns, 4);
  XtSetArg(args[2], XmNx, 90);
  XtSetArg(args[3], XmNy, 50);
  text_mp=XmCreateText(form_esep, "text_mp", args, 4);
  XtManageChild(text_mp);

  xms = XmStringLtoRCreate("-mq", XmSTRING_DEFAULT_CHARSET);
  XtSetArg(args[0], XmNlabelString, xms);
  XtSetArg(args[1], XmNx, 135);
  XtSetArg(args[2], XmNy, 55);
  label_mq=XmCreateLabel(form_esep, "label_mq", args, 3);
  XtManageChild(label_mq);
  XmStringFree(xms);

  XtSetArg(args[0], XmNeditable, True);
  XtSetArg(args[1], XmNcolumns, 4);
  XtSetArg(args[2], XmNx, 160);
  XtSetArg(args[3], XmNy, 50);
  text_mq=XmCreateText(form_esep, "text_mq", args, 4);
  XtManageChild(text_mq);

  xms = XmStringLtoRCreate("-q", XmSTRING_DEFAULT_CHARSET);
  XtSetArg(args[0], XmNlabelString, xms);
  XtSetArg(args[1], XmNx, 205);
  XtSetArg(args[2], XmNy, 55);
  label_q=XmCreateLabel(form_esep, "label_q", args, 3);
  XtManageChild(label_q);
  XmStringFree(xms);

  XtSetArg(args[0], XmNeditable, True);
  XtSetArg(args[1], XmNcolumns, 2);
  XtSetArg(args[2], XmNx, 225);
  XtSetArg(args[3], XmNy, 50);
  text_q=XmCreateText(form_esep, "text_q", args, 4);
  XtManageChild(text_q);

  xms = XmStringLtoRCreate("-po", XmSTRING_DEFAULT_CHARSET);
  XtSetArg(args[0], XmNlabelString, xms);
  XtSetArg(args[1], XmNx, 260);
  XtSetArg(args[2], XmNy, 55);
  label_po=XmCreateLabel(form_esep, "label_po", args, 3);
  XtManageChild(label_po);
  XmStringFree(xms);

  XtSetArg(args[0], XmNeditable, True);
  XtSetArg(args[1], XmNcolumns, 15);
  XtSetArg(args[2], XmNx, 285);
  XtSetArg(args[3], XmNy, 50);
  text_po=XmCreateText(form_esep, "text_po", args, 4);
  XtManageChild(text_po);

  xms = XmStringLtoRCreate("-qo", XmSTRING_DEFAULT_CHARSET);
  XtSetArg(args[0], XmNlabelString, xms);
  XtSetArg(args[1], XmNx, 410);
  XtSetArg(args[2], XmNy, 55);
  label_qo=XmCreateLabel(form_esep, "label_qo", args, 3);
  XtManageChild(label_qo);
  XmStringFree(xms);

  XtSetArg(args[0], XmNeditable, True);
  XtSetArg(args[1], XmNcolumns, 15);
  XtSetArg(args[2], XmNx, 435);
  XtSetArg(args[3], XmNy, 50);
  text_qo=XmCreateText(form_esep, "text_qo", args, 4);
  XtManageChild(text_qo);

  XtRealizeWidget(top_level);
  XtAppMainLoop(app);
}

void files(Widget w, XtPointer data, XmAnyCallbackStruct *call_data)
{
  int sel;

  sel=*((int *)data);
  switch(sel)
  {
    case 0:
      sprintf(buf, "%s %d &", "xesep-ss", msec);
      system(buf);
      print_status(buf);
      break;
    case 1:
      sprintf(buf, "%s %d &", "xesep-ps", msec);
      system(buf);
      print_status(buf);
      break;
    case 2:
      sprintf(buf, "%s %d &", "xesep-qs", msec);
      system(buf);
      print_status(buf);
      break;
    case 3:
      sprintf(buf, "%s %d &", "xesep-es", msec);
      system(buf);
      print_status(buf);
      break;
    case 4:
      XtCloseDisplay(XtDisplay(w));
      exit(0);
    default:
  }
}

void options(Widget w, XtPointer data, XmAnyCallbackStruct *call_data)
{
  int sel;

  sel=*((int *)data);
  switch(sel)
  {
    case 0:
      msec=1;
      print_status("1 msecond");
      break;
    case 1:
      msec=10;
      print_status("10 mseconds");
      break;
    case 2:
      msec=100;
      print_status("100 mseconds");
      break;
    case 3:
      msec=1000;
      print_status("1 second");
      break;
    case 4:
      msec=2000;
      print_status("2 seconds");
      break;
    case 5:
      msec=3000;
      print_status("3 seconds");
      break;
    case 6:
      msec=10000;
      print_status("10 seconds");
      break;
    case 7:
      msec=20000;
      print_status("20 seconds");
      break;
    default:
  }
}

Widget MakeMenuPane(va_alist)
va_dcl 
{
  va_list argp;
  Widget new_menu, button, parent;
  char *item_label;
  P_FUNC item_action;
  caddr_t  action_args;
  char *name;

  va_start(argp);
  name = va_arg(argp, P_CHAR);
  parent = va_arg(argp, Widget);

  new_menu = XmCreatePulldownMenu(parent, name, NULL, 0);

  while((item_label = va_arg(argp, P_CHAR)) != NULL)
  {
    button = XmCreatePushButton(new_menu, item_label, NULL, 0);

    item_action = va_arg(argp, P_FUNC);
    action_args = va_arg(argp, caddr_t);
                      
    XtAddCallback(button, XmNactivateCallback, 
                      item_action, action_args);
    XtManageChild (button);
  }
  va_end(argp);
  return(new_menu);
}

void AttachToCascade(Widget parent, char *label, Widget sub_menu)
{
  Arg args[10];
  Cardinal argcount;
  Widget cbutton;

  argcount = 0;
  XtSetArg(args[argcount], XmNsubMenuId, sub_menu);   
  argcount++;
  cbutton = XmCreateCascadeButton(parent, label, args, argcount);
  XtManageChild(cbutton);
}

